using System;
using System.Collections.Generic;
using Avalonia.Controls;
using Avalonia.Controls.Shapes;
using Avalonia.Media;
using ReactiveUI;
using Tmds.DBus.Protocol;
using static System.Runtime.InteropServices.JavaScript.JSType;

namespace AvaloniaCalculator.ViewModels
{
	public class AuthViewModel : ReactiveObject
	{
        string _login = "";
        string _password = "";
        bool _refundRez = false;
        bool _refundRezCaptcha = false;
        bool _isVisibleButton = true;
        bool _isVisiblePanelCaptcha = false;
        bool _enabled = true;
        public char[] _stringCaptcha;
        string _enterCaptcha = "";
        public int count = 0;
        public string EnteredLogin
        {
            get => _login;
            set => this.RaiseAndSetIfChanged(ref _login, value);
        }
        public string EnteredPassword
        {
            get => _password;
            set => this.RaiseAndSetIfChanged(ref _password, value);
        }
        public bool IsVisibleButton
        {
            get => _isVisibleButton;
            set => this.RaiseAndSetIfChanged(ref _isVisibleButton, value);
        }
        public bool IsVisiblePanelCaptcha
        {
            get => _isVisiblePanelCaptcha;
            set => this.RaiseAndSetIfChanged(ref _isVisiblePanelCaptcha, value);
        }
        public bool Enabledhange
        {
            get => _enabled;
            set => this.RaiseAndSetIfChanged(ref _enabled, value);
        }
        public bool RefundRez
        {
            get => _refundRez;
            set => this.RaiseAndSetIfChanged(ref _refundRez, value);
        }
        public bool RefundRezCaptcha
        {
            get => _refundRezCaptcha;
            set => this.RaiseAndSetIfChanged(ref _refundRezCaptcha, value);
        }
        public string EnterCaptcha
        {
            get => _enterCaptcha;
            set => this.RaiseAndSetIfChanged(ref _enterCaptcha, value);
        }
        Canvas _canvas;
        public Canvas Captcha
        {
            get => _canvas;
            set => this.RaiseAndSetIfChanged(ref _canvas, value);
        }
        public void CreateCaptcha()
        {
            Random rnd = new Random();
            SolidColorBrush color = new SolidColorBrush(Color.FromRgb(Convert.ToByte(rnd.Next(256)), Convert.ToByte(rnd.Next(255)), Convert.ToByte(rnd.Next(255))));
            FontStyle[] fontStyles = new FontStyle[2] { FontStyle.Normal, FontStyle.Italic };
            FontWeight[] fontWeights = new FontWeight[2] { FontWeight.Normal, FontWeight.Bold };
            Canvas canvas = new Canvas()
            {
                Width = 400,
                Height = 400,
                Background = color
            };
            //  
            int lineLen = rnd.Next(50, 100);
            for (int i = 0; i < lineLen; i++)
            {
                SolidColorBrush colorLine = new SolidColorBrush(Color.FromRgb(Convert.ToByte(rnd.Next(256)), Convert.ToByte(rnd.Next(255)), Convert.ToByte(rnd.Next(255))));
                Line line = new Line()
                {
                    StartPoint = new Avalonia.Point(rnd.Next(400), rnd.Next(400)),
                    EndPoint = new Avalonia.Point(rnd.Next(400), rnd.Next(400)),
                    Stroke = colorLine,
                    StrokeThickness = 2
                };
                canvas.Children.Add(line);
            }

            // 
            string str = "abcdefghijklmnopqrstuvwxyz0123456789";
            _stringCaptcha = new char[rnd.Next(7, 11)];
            int FS = rnd.Next(0, 3);//
            for (int i = 0; i < _stringCaptcha.Length; i++)
            {
                _stringCaptcha[i] = str[rnd.Next(str.Length)];
            }
            int distance = 40;
            int startDistance = 15;
            for (int i = 0; i < _stringCaptcha.Length; i++)
            {
                TextBlock symbol = new TextBlock()
                {
                    Text = _stringCaptcha[i].ToString(),
                    FontSize = 30,
                    Margin = new Avalonia.Thickness(startDistance, rnd.Next(150, 200), 0, 0),
                    FontStyle = fontStyles[rnd.Next(0, 2)],
                    FontWeight = fontWeights[rnd.Next(0, 2)],
                };
                startDistance += distance;
                canvas.Children.Add(symbol);
            }
            Captcha = canvas;
        }

    }
}