﻿using Avalonia.Controls;
using Avalonia.Media.TextFormatting.Unicode;
using Avalonia.Threading;
using ReactiveUI;
using System;

namespace AvaloniaCalculator.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {
        UserControl _us = new Authorization();
        public UserControl US
        {
            get => _us;
            set => this.RaiseAndSetIfChanged(ref _us, value);
        }
        AuthViewModel _auth = new AuthViewModel();
        public AuthViewModel Auth
        {
            get => _auth;
            set => _auth = value;
        }
        CalculatorViewModel _calc = new CalculatorViewModel();
        public CalculatorViewModel Calc
        {
            get => _calc;
            set => _calc = value;
        }
        public void ToPageCalculator()
        {
            US = new Calculator();
        }
        public void CheckData()
        {
            if (Auth.EnteredLogin == Models.AuthClass.Login && Auth.EnteredPassword == Models.AuthClass.Password)
            {
                ToPageCalculator();
            }
            else
            {
                Auth.IsVisibleButton = false;
                Auth.IsVisiblePanelCaptcha = true;
                Auth.RefundRez = true;
                Auth.CreateCaptcha();
                Auth.count++;
            }
        }
        public void CheckCaptcha()
        {
            bool flag = false;
            if (Auth.count != 2)
            {
                if (Auth.count == 1)
                {
                    flag = true;
                }
                else if (Auth.EnteredLogin == Models.AuthClass.Login && Auth.EnteredPassword == Models.AuthClass.Password)
                {
                    string captcha = new string(Auth.EnterCaptcha);
                    if (Auth.EnterCaptcha == captcha)
                    {
                        ToPageCalculator();
                    }
                    else
                    {
                        Auth.RefundRez = false;
                        Auth.RefundRezCaptcha = true;
                        Auth.CreateCaptcha();
                        Auth.count++;
                    }
                }
                else
                {
                    Auth.RefundRez = false;
                    Auth.RefundRezCaptcha = true;
                    Auth.CreateCaptcha();
                    Auth.count++;
                }
            }
            else
            {
                flag = true;
            }
            if (flag == true)
            {
                Auth.IsVisiblePanelCaptcha = false;
                Auth.EnteredLogin = "";
                Auth.EnteredPassword = "";
                Auth.EnterCaptcha = "";
                Auth.RefundRez = false;
                Auth.RefundRezCaptcha = false;
                Auth.EnabledСhange = false;
                DispatcherTimer timer = new DispatcherTimer();
                timer.Interval = new TimeSpan(0, 0, 10);
                timer.Tick += (sender, e) =>
                {
                    Auth.IsVisiblePanelCaptcha = true;
                    Auth.EnabledСhange = true;
                    Auth.count = 0;
                    Auth.CreateCaptcha();
                    timer.Stop();
                };
                timer.Start();
            }
        }
        private void Timer_Tick(object? sender, EventArgs e)
        {
            throw new NotImplementedException();
        }
    }
}